/// <reference types="node" />
declare type ValidFontExt = 'ttf' | 'otf' | 'woff' | 'woff2';
declare type Config = {
    global: boolean;
    fast: boolean;
    interactive: boolean;
    preferenceOrder: [ValidFontExt, ValidFontExt, ValidFontExt, ValidFontExt];
};
declare type Result = {
    result: 'was_added' | 'already_added' | 'error';
    path: string | null;
    error: string | null;
    fontName: string | null;
};
export declare const getDestDir: (global: boolean, ext: string, platform?: NodeJS.Platform) => string;
export declare const clearFontCache: (platform?: NodeJS.Platform) => Promise<boolean>;
export declare const installFont: (filePath: string, config?: Partial<Config> | undefined) => Promise<Result>;
export declare const installFontsFromDir: (dirPath: string, config?: Partial<Config> | undefined) => Promise<Result[]>;
export {};
