import rawfs from 'fs';
import mkdirp from 'mkdirp';
import rimraf from 'rimraf';
import path from 'path';
import os from 'os';
import fontkit from 'fontkit';
import { fromFile } from 'file-type';
import { toSfnt } from 'woff-tools';
import { exec, execSync } from 'child_process';
import tmp from 'tmp';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

var fs = rawfs.promises;
var defaultConfig = {
  global: false,
  fast: false,
  interactive: true,
  preferenceOrder: ['ttf', 'otf', 'woff', 'woff2']
};

var pathIsFile = function pathIsFile(filePath) {
  return __awaiter(void 0, void 0, void 0, function () {
    var stats, e_1;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          _a.trys.push([0, 2,, 3]);

          return [4, fs.stat(filePath)];

        case 1:
          stats = _a.sent();
          return [2, stats.isFile()];

        case 2:
          e_1 = _a.sent();
          return [2, false];

        case 3:
          return [2];
      }
    });
  });
};

var pathIsDir = function pathIsDir(filePath) {
  return __awaiter(void 0, void 0, void 0, function () {
    var stats, e_2;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          _a.trys.push([0, 2,, 3]);

          return [4, fs.stat(filePath)];

        case 1:
          stats = _a.sent();
          return [2, stats.isDirectory()];

        case 2:
          e_2 = _a.sent();
          return [2, false];

        case 3:
          return [2];
      }
    });
  });
};

var asyncExec = function asyncExec(cmd) {
  return new Promise(function (resolve) {
    exec(cmd, function (err, stdout, stderr) {
      resolve({
        err: err,
        stdout: stdout,
        stderr: stderr
      });
    });
  });
};

var getDestDir = function getDestDir(global, ext, platform) {
  if (platform === void 0) {
    platform = os.platform();
  }

  var destDir;

  if (platform === 'linux') {
    if (global) {
      destDir = "/usr/share/fonts/" + (ext === 'otf' ? 'opentype' : 'truetype');
    } else {
      destDir = path.join(os.homedir(), '.fonts');
    }
  } else {
    if (global) {
      destDir = '/Library/Fonts';
    } else {
      destDir = path.join(os.homedir(), 'Library/Fonts');
    }
  }

  return destDir;
};
var clearFontCache = function clearFontCache(platform) {
  if (platform === void 0) {
    platform = os.platform();
  }

  return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          if (!(platform === 'darwin')) return [3, 4];
          return [4, asyncExec("sudo atsutil databases -remove")];

        case 1:
          _a.sent();

          return [4, asyncExec("atsutil server -shutdown")];

        case 2:
          _a.sent();

          return [4, asyncExec("atsutil server -ping")];

        case 3:
          _a.sent();

          return [3, 6];

        case 4:
          return [4, asyncExec("sudo fc-cache -f -v")];

        case 5:
          _a.sent();

          _a.label = 6;

        case 6:
          return [2, true];
      }
    });
  });
};
var installFont = function installFont(filePath, config) {
  return __awaiter(void 0, void 0, void 0, function () {
    var cfg, fullPath, ext, fileData, fileExt, fontData, destDir, finalFilePath, _a, _b, _c, _d, isInstalled, tmpobj, startFilePath, endFilePath, _e, _f, _g, e_3;

    var _h;

    return __generator(this, function (_j) {
      switch (_j.label) {
        case 0:
          cfg = __assign(__assign({}, defaultConfig), config);
          fullPath = path.resolve(process.cwd(), filePath);
          _j.label = 1;

        case 1:
          _j.trys.push([1, 28,, 29]);

          return [4, pathIsFile(fullPath)];

        case 2:
          if (!_j.sent()) return [3, 26];
          ext = fullPath.slice(fullPath.lastIndexOf('.') + 1).toLowerCase();
          if (!!cfg.fast) return [3, 4];
          return [4, fromFile(fullPath)];

        case 3:
          fileData = _j.sent();
          fileExt = (_h = fileData === null || fileData === void 0 ? void 0 : fileData.ext) !== null && _h !== void 0 ? _h : '';
          if (fileExt) ext = fileExt;
          _j.label = 4;

        case 4:
          if (!ext) return [3, 24];
          if (!cfg.preferenceOrder.includes(ext)) return [3, 22];
          fontData = fontkit.openSync(fullPath);
          destDir = getDestDir(cfg.global, ext);
          mkdirp.sync(destDir);
          finalFilePath = path.join(destDir, fontData.fullName + "." + (ext === 'otf' ? 'otf' : 'ttf'));
          return [4, pathIsFile(finalFilePath)];

        case 5:
          if (!_j.sent()) return [3, 6];
          return [2, {
            result: 'already_added',
            path: finalFilePath,
            fontName: fontData.fullName,
            error: "The font '" + fontData.fullName + "' is already installed"
          }];

        case 6:
          if (!(os.platform() === 'linux' && cfg.global && pathIsFile("/usr/share/fonts/" + (ext === 'otf' ? 'truetype' : 'opentype') + "/" + fontData.fullName + "." + (ext === 'otf' ? 'ttf' : 'otf')))) return [3, 7];
          return [2, {
            result: 'already_added',
            path: finalFilePath,
            fontName: fontData.fullName,
            error: "The font '" + fontData.fullName + "' is already installed as an " + (ext === 'otf' ? 'truetype' : 'opentype') + " font"
          }];

        case 7:
          if (!(ext === 'ttf' || ext === 'otf')) return [3, 9];
          rimraf.sync(finalFilePath);
          return [4, fs.copyFile(fullPath, finalFilePath)];

        case 8:
          _j.sent();

          return [2, {
            result: 'was_added',
            path: finalFilePath,
            fontName: fontData.fullName,
            error: null
          }];

        case 9:
          if (!(ext === 'woff')) return [3, 12];
          _b = (_a = fs).writeFile;
          _c = [finalFilePath];
          _d = toSfnt;
          return [4, fs.readFile(fullPath)];

        case 10:
          return [4, _b.apply(_a, _c.concat([_d.apply(void 0, [_j.sent()])]))];

        case 11:
          _j.sent();

          return [2, {
            result: 'was_added',
            path: finalFilePath,
            fontName: fontData.fullName,
            error: null
          }];

        case 12:
          if (!(ext === 'woff2')) return [3, 20];
          return [4, new Promise(function (resolve) {
            exec("woff2_decompress", function (_0, _1, stderr) {
              if (("" + stderr).includes('One argument')) {
                resolve(true);
              } else {
                resolve(false);
              }
            });
          })];

        case 13:
          isInstalled = _j.sent();
          if (!isInstalled) return [3, 18];
          tmpobj = tmp.dirSync();
          startFilePath = path.join(tmpobj.name, fontData.fullName + ".woff2");
          endFilePath = path.join(tmpobj.name, fontData.fullName + ".ttf");
          rimraf.sync(startFilePath);
          rimraf.sync(endFilePath);
          return [4, fs.copyFile(fullPath, startFilePath)];

        case 14:
          _j.sent();

          execSync("woff2_decompress '" + startFilePath + "'");
          rimraf.sync(finalFilePath);
          _f = (_e = fs).writeFile;
          _g = [finalFilePath];
          return [4, fs.readFile(endFilePath)];

        case 15:
          return [4, _f.apply(_e, _g.concat([_j.sent()]))];

        case 16:
          _j.sent();

          return [4, fs.unlink(endFilePath)];

        case 17:
          _j.sent();

          return [2, {
            result: 'was_added',
            path: finalFilePath,
            fontName: fontData.fullName,
            error: null
          }];

        case 18:
          return [2, {
            result: 'error',
            path: finalFilePath,
            fontName: fontData.fullName,
            error: 'woff2 needs to be installed to convert woff2 font files'
          }];

        case 19:
          return [3, 21];

        case 20:
          return [2, {
            result: 'error',
            path: finalFilePath,
            fontName: fontData.fullName,
            error: 'Unsupported input font file format'
          }];

        case 21:
          return [3, 23];

        case 22:
          return [2, {
            result: 'error',
            path: null,
            fontName: null,
            error: 'Can only install ttf, otf, woff and woff2 fonts'
          }];

        case 23:
          return [3, 25];

        case 24:
          return [2, {
            result: 'error',
            path: null,
            fontName: null,
            error: "Could not determine file type of '" + fullPath + "'."
          }];

        case 25:
          return [3, 27];

        case 26:
          return [2, {
            result: 'error',
            path: null,
            fontName: null,
            error: "File '" + fullPath + "' not found."
          }];

        case 27:
          return [3, 29];

        case 28:
          e_3 = _j.sent();
          console.error(e_3);
          return [2, {
            result: 'error',
            path: null,
            fontName: null,
            error: e_3.message
          }];

        case 29:
          return [2];
      }
    });
  });
};

function walk(dir) {
  return __asyncGenerator(this, arguments, function walk_1() {
    var _a, _b, d, entry, e_4_1;

    var e_4, _c;

    return __generator(this, function (_d) {
      switch (_d.label) {
        case 0:
          _d.trys.push([0, 12, 13, 18]);

          return [4, __await(fs.opendir(dir))];

        case 1:
          _a = __asyncValues.apply(void 0, [_d.sent()]);
          _d.label = 2;

        case 2:
          return [4, __await(_a.next())];

        case 3:
          if (!(_b = _d.sent(), !_b.done)) return [3, 11];
          d = _b.value;
          entry = path.join(dir, d.name);
          if (!d.isDirectory()) return [3, 7];
          return [4, __await(walk(entry))];

        case 4:
          return [5, __values(__asyncDelegator.apply(void 0, [__asyncValues.apply(void 0, [_d.sent()])]))];

        case 5:
          return [4, __await.apply(void 0, [_d.sent()])];

        case 6:
          _d.sent();

          return [3, 10];

        case 7:
          if (!d.isFile()) return [3, 10];
          return [4, __await(entry)];

        case 8:
          return [4, _d.sent()];

        case 9:
          _d.sent();

          _d.label = 10;

        case 10:
          return [3, 2];

        case 11:
          return [3, 18];

        case 12:
          e_4_1 = _d.sent();
          e_4 = {
            error: e_4_1
          };
          return [3, 18];

        case 13:
          _d.trys.push([13,, 16, 17]);

          if (!(_b && !_b.done && (_c = _a["return"]))) return [3, 15];
          return [4, __await(_c.call(_a))];

        case 14:
          _d.sent();

          _d.label = 15;

        case 15:
          return [3, 17];

        case 16:
          if (e_4) throw e_4.error;
          return [7];

        case 17:
          return [7];

        case 18:
          return [2];
      }
    });
  });
}

var installFontsFromDir = function installFontsFromDir(dirPath, config) {
  return __awaiter(void 0, void 0, void 0, function () {
    var cfg, fullDirPath, fontMap, _a, _b, p, ext, fileData, fileExt, fontData, prevMatchingFont, e_5_1;

    var e_5, _c;

    var _d;

    return __generator(this, function (_e) {
      switch (_e.label) {
        case 0:
          cfg = __assign(__assign({}, defaultConfig), config);
          fullDirPath = path.resolve(process.cwd(), dirPath);

          if (!pathIsDir(fullDirPath)) {
            throw new Error("Input dirPath does not exist, or is not a directory");
          }

          fontMap = new Map();
          _e.label = 1;

        case 1:
          _e.trys.push([1, 8, 9, 14]);

          _a = __asyncValues(walk(fullDirPath));
          _e.label = 2;

        case 2:
          return [4, _a.next()];

        case 3:
          if (!(_b = _e.sent(), !_b.done)) return [3, 7];
          p = _b.value;
          ext = p.slice(p.lastIndexOf('.') + 1).toLowerCase();
          if (!!cfg.fast) return [3, 5];
          return [4, fromFile(p)];

        case 4:
          fileData = _e.sent();
          fileExt = (_d = fileData === null || fileData === void 0 ? void 0 : fileData.ext) !== null && _d !== void 0 ? _d : '';
          if (fileExt) ext = fileExt;
          _e.label = 5;

        case 5:
          if (ext) {
            if (ext === 'ttf' || ext === 'otf' || ext === 'woff' || ext === 'woff2') {
              fontData = fontkit.openSync(p);
              prevMatchingFont = fontMap.get(fontData.fullName);

              if (!prevMatchingFont || cfg.preferenceOrder.indexOf(ext) < cfg.preferenceOrder.indexOf(prevMatchingFont.ext)) {
                fontMap.set(fontData.fullName, {
                  path: p,
                  ext: ext,
                  fontData: fontData
                });
              }
            }
          }

          _e.label = 6;

        case 6:
          return [3, 2];

        case 7:
          return [3, 14];

        case 8:
          e_5_1 = _e.sent();
          e_5 = {
            error: e_5_1
          };
          return [3, 14];

        case 9:
          _e.trys.push([9,, 12, 13]);

          if (!(_b && !_b.done && (_c = _a["return"]))) return [3, 11];
          return [4, _c.call(_a)];

        case 10:
          _e.sent();

          _e.label = 11;

        case 11:
          return [3, 13];

        case 12:
          if (e_5) throw e_5.error;
          return [7];

        case 13:
          return [7];

        case 14:
          return [2, Promise.all(__spread(fontMap.values()).map(function (entry) {
            var path = entry.path,
                fontData = entry.fontData;
            return installFont(path, cfg).then(function (result) {
              return __assign(__assign({}, result), {
                fontName: fontData.familyName + " " + fontData.subfamilyName
              });
            });
          })).then(function (results) {
            return __awaiter(void 0, void 0, void 0, function () {
              var fontsInstalled, fontsAlreadyInstalled, results_1, results_1_1, result;

              var e_6, _a;

              return __generator(this, function (_b) {
                switch (_b.label) {
                  case 0:
                    fontsInstalled = [];
                    fontsAlreadyInstalled = [];

                    try {
                      for (results_1 = __values(results), results_1_1 = results_1.next(); !results_1_1.done; results_1_1 = results_1.next()) {
                        result = results_1_1.value;

                        if (result.result === 'error') {
                          console.log("'" + result.fontName + "' was not installed:\n  " + result.error);
                        } else if (result.result === 'was_added') {
                          fontsInstalled.push(result);
                        } else {
                          fontsAlreadyInstalled.push(result);
                        }
                      }
                    } catch (e_6_1) {
                      e_6 = {
                        error: e_6_1
                      };
                    } finally {
                      try {
                        if (results_1_1 && !results_1_1.done && (_a = results_1["return"])) _a.call(results_1);
                      } finally {
                        if (e_6) throw e_6.error;
                      }
                    }

                    if (fontsInstalled.length > 0) {
                      console.log("Fonts installed:\n" + __spread(fontsInstalled.values()).sort(function (a, b) {
                        return a.fontName > b.fontName ? 1 : -1;
                      }).map(function (_a) {
                        var fontName = _a.fontName;
                        return "  " + fontName;
                      }).join('\n'));
                    }

                    if (fontsAlreadyInstalled.length > 0) {
                      console.log("Fonts encountered that were previously installed:\n" + __spread(fontsAlreadyInstalled.values()).sort(function (a, b) {
                        return a.fontName > b.fontName ? 1 : -1;
                      }).map(function (_a) {
                        var fontName = _a.fontName;
                        return "  " + fontName;
                      }).join('\n'));
                    }

                    if (!cfg.interactive) return [3, 2];
                    return [4, clearFontCache()];

                  case 1:
                    _b.sent();

                    _b.label = 2;

                  case 2:
                    return [2, results];
                }
              });
            });
          })];
      }
    });
  });
};

export { clearFontCache, getDestDir, installFont, installFontsFromDir };
//# sourceMappingURL=install-custom-font.esm.js.map
